/***************************************************************************
                          evtmapper.h  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk

 ***************************************************************************/

#ifndef EVTMAPPER_H
#define EVTMAPPER_H

#include "configuration.h"
#include <SDL.h>

namespace CMDFUNCTION {
	typedef enum Function {
		TARGET_MASK		= 0xff00,
		HOTKEY   			= 0x0000,
		PLAYER1 			= 0x0100,
		PLAYER2 			= 0x0200,

		FUNCTION_MASK = 0x00ff,
    NONE 					= 0x0000,

		//player controls:
		UP,
		DOWN,
		LEFT,
		RIGHT,
		FIRE,
		JUMP,
		DIG,
		HOOK_FIRE,
		HOOK_RELEASE,
		HOOK_IN,
		HOOK_OUT,
		WEAPON1,
		WEAPON2,
		WEAPON3,
		WEAPON4,
		WEAPON5,
		NEXTWEAPON,
		PREVWEAPON,

		//other hotkeys:
		SCREEN_SHOOT,
		TOGGLE_LOGO,
		TOGGLE_DEATHCAM,
		TOGGLE_TRAFFIC,
		TOGGLE_FRAMERATE,
		TOGGLE_SHADOW,
		TOGGLE_SMOOTH,

		MENU
	};
};

// used for both keyboard and joystick events.
typedef struct Nil_inputevent {
	SDL_Event *sdl_inputevent;
	CMDFUNCTION::Function cmdfunction;
	bool pressed;
};

class Evtmapper_bindings;
class Evtmapper : protected Configuration_observer {
public: 
	Evtmapper();
	virtual ~Evtmapper();
	
	bool lookup(Nil_inputevent &inputevent);
	void init(Configuration *config_);

	Evtmapper_bindings *get_bindings() {return bindings;}

	virtual void config_changed();

	void bindkey(CMDFUNCTION::Function function, SDLKey sdlsym);

protected:
	void addplayerkeys(CMDFUNCTION::Function player);
	Evtmapper_bindings *bindings;		
};

#endif

