/***************************************************************************
                          obj_scoreboard.h  -  description
                             -------------------
    begin                : Sun Dec 26 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef OBJ_SCOREBOARD_H
#define OBJ_SCOREBOARD_H

#include "obj_base.h"

#define KEEP_FRAGS 3
#define KEEP_FRAG_TIME 8

/**
  *@author Flemming Frandsen
  */

class Obj_scoreboard : public Obj_base  {
public: 
	Obj_scoreboard(World *world_, int id);
	virtual ~Obj_scoreboard();
	
	virtual Object_type gettype() {return ot_scoreboard;}
	virtual void serialize(Serializer *serializer);

 	virtual void server_think();
	virtual void draw(Viewport *viewport){}
	virtual void client_think(){}

	void addfrag(int killer_id, int victim_id);
	
	//Getting the scores out again:
	typedef struct Score {
		int player_id;
  	int kills;
		int deaths;
		int frags;
		char playername[80];
	};

	Score getscore(int index);
	int getscore_count() {return scores_inuse;}
	
  // it's nice to keep in mind last few frags
	// FIXME: It should be keeped and displayed some different way
	int frags_inuse;
	int last_killers [ KEEP_FRAGS ];
	int last_victims [ KEEP_FRAGS ];
	float keep_frag_time [ KEEP_FRAGS ];

	void dump();
protected:

	int get_index(int player_id);
	
	Score scores[256];
	int scores_inuse;	
};

#endif


