/***************************************************************************
                          sound_event.h  -  description
                             -------------------
    begin                : Sat Aug 17 2002
    copyright            : (C) 2002 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#ifndef SOUND_EVENT_H
#define SOUND_EVENT_H

#include <time.h>
#include <map>

#define	SOUND_LOOPING	0x01
#define SOUND_GLOBAL	0x02
#define SOUND_STATIC	0x04
#define SOUND_OBJECT	0x08
#define SOUND_DONE	0x10
#define SOUND_DIRTY	0x20

class Game_client;
class Soundsystem;
class Serializer_reader;

class Sound_event {
	public:

	Sound_event(char *sample_name_, int flags_, float volume_, float x_pos_, float y_pos_, int objectid_, Soundsystem *soundsystem_);
	~Sound_event();

	void update(Game_client *game_client);
	void send_event(Serializer_reader *serializer_reader);
	void bedone();
	void check_timer(struct timeval &now);

	int flags;

	protected:

	Soundsystem *soundsystem;

	char *name;
	int channel;
	float volume;
	struct timeval expire;

	int objectid;
	float x_pos;
	float y_pos;
};

class Sound_events_handle : public std::map<int, Sound_event*> {};
// List of server handles and their matching client handles
class Sound_handles_server : public std::map<int, int> {};

#endif

