/***************************************************************************
                          sounds.cpp  -  description
                             -------------------
    begin                : Thu Aug 15 2002
    copyright            : (C) 2002 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#include "fluff.h"
#include "sounds.h"
#include "sound.h"
#include "loader.h"
#include "map"
#include "string"
#include "SDL_mixer.h"

// The hash map blabla... you fix it ;)
class Sounds_loaded : public std::map<std::string,Sound*>{};

//-----------------------------------------------------------------------------
Sounds::Sounds()
{
	sounds = new Sounds_loaded;
	loader = NULL;
}

//-----------------------------------------------------------------------------
Sounds::~Sounds()
{
	// In case soundsystem didn't close it already
	Mix_CloseAudio(); // Else the mess might segfault
	
	Sounds_loaded::iterator i = sounds->begin();
	while (i != sounds->end())
		delete (i++)->second;
	delete sounds;
}

//-----------------------------------------------------------------------------
void Sounds::init(Loader *loader_)
{
	loader = loader_;
}

//-----------------------------------------------------------------------------
Sound *Sounds::getsound(char *name, bool loadchunk)
{
	Sounds_loaded::iterator i = sounds->find(name);
	
	// Sounds was already loaded
	if (i != sounds->end())
		return i->second;
	
	Sound *sound = new Sound;
	sounds->insert(std::pair<std::string,Sound*>(name,sound));
	
	if (!sound->load(loader,name,loadchunk)) {
		logmsg(lt_error,"sound %s could _NOT_ be loaded. No soup for you!",name);
		i = sounds->find(name);
		if (i != sounds->end()) sounds->erase(i);
		delete sound;
		return NULL;
	}
	
	logmsg(lt_debug,"sound %s loaded",name);
	return sound;
}
