/***************************************************************************
                          viewport.h  -  description
                             -------------------
    begin                : Mon Oct 11 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/
#ifndef VIEWPORT_H
#define VIEWPORT_H

#include "systemheaders.h"

#include "graphics.h"
#include "raw_surface.h"

/**
	This class is just a comfy place to stick all the
 	info needed for rendering a view of the arena

	Note: some viewports are "owned" by an object.  This is used
	for a few things such as drawing crosshairs.  (it used to be that
	this was stored in the world, but since multiple players can be on
	one computer, this no longer works)
*/

class Graphics;

class Viewport : public Mutable_raw_surface
{
	public:

	Viewport(int width, int height, int owner);
	~Viewport();

	void setmapsize(int map_xsize_, int map_ysize_) {map_xsize = map_xsize_; map_ysize = map_ysize_;}

	void drop_shadow();

	void setpos(int x, int y);

	//coordinats of the topleft corner on the bit map
	int xpos;
	int ypos;
	int map_xsize;
	int map_ysize;
 	void addsample(int x, int y,float dt);

	int getowner() {return ownerid;}

	protected:

	//owner of this viewport.
	int ownerid;

	float xesum;
	float yesum;
	float xspeed;
	float yspeed;
	float xcenter;
	float ycenter;
};

#endif





